import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class GGuy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class GGuy extends Actor
{
    
    private final int Gravity=1;
    private int velocity;
   public int coins=0;
   public int lives=3;
   public static boolean wasHit;
   public static boolean wasHit2=false;
    public GGuy(){
        //This calculation is used to set the image at a proper size.
        GreenfootImage image = getImage();
        image.scale(100,100);
        velocity = 0;
    }
    /**
     * Act - do whatever the GGuy wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
     
        fall();
        //This if statement causes the actor to jump when "w" is pressed.
        if(Greenfoot.isKeyDown("w")&& isOnSolidGround()){
            jump();
        }
        move();
       //This if statement causes the actor th respawn when it falls down the hole;
       if(getY()>getWorld().getHeight()-10){
           setLocation(60,1190);
        }
       touchCoin();
       showStats();
       kill();
       kill2();
       changeScreen();
    }
    /**
     * The method is called to check if the actor can fall
     * 
     * 
    */
    public void fall(){
        setLocation(getX(), getY() + velocity);
      //Checks if the actor is on a platform and if not, then causes the actor to move down to one.
      if(isOnSolidGround()){
        velocity = 0;
        }
        else if(velocity<0 && didBumpHead()){
        velocity=0;
        }
      else{
         velocity+=Gravity;
         
        }
    }
    /**
     * The method is called to make the actor jump
     * 
     * 
    */
    public void jump(){
        //Moves the actor up
        velocity= -25;
    }
    /**
     * The method is called to make the actor move left and right
     * 
     * 
    */
    public void move(){
        int y = getY();
        int x = getX();
        //When "a" is pressed the image moves left
        if(Greenfoot.isKeyDown("a")){
            setImage("download.png");
            x-=8;
            GreenfootImage image = getImage();
        image.scale(100,100);
        }
        //When "d" is pressed the image moves right
        if(Greenfoot.isKeyDown("d")){
            setImage("download copy.png");
            x+=8;
            
            GreenfootImage image = getImage();
        image.scale(100,100);
        }
        setLocation(x, y);
    }
    /**
     * The method is called to check if the actor is on a platform or not
     * 
     * 
    */
    public boolean isOnSolidGround(){
        boolean isOnGround = false;
        //Gets dimensions
        int imageWidth = getImage().getWidth();
        int imageHeight = getImage().getHeight();
        //Checks if the actor is on a platform or not
        if(getOneObjectAtOffset(0,imageHeight/2+1,Platform.class)!=null){
            isOnGround = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/2+1,Platform2.class)!=null){
            isOnGround = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/2+1,Platform3.class)!=null){
            isOnGround = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/2+1,Floor.class)!=null){
            isOnGround = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/2+1,Floor2.class)!=null){
            isOnGround = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/2+1,Platform4.class)!=null){
            isOnGround = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/2+1,Platform5.class)!=null){
            isOnGround = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/2+1,Platform6.class)!=null){
            isOnGround = true;
        }
          if(getOneObjectAtOffset(0,imageHeight/2+1,Platform7.class)!=null){
            isOnGround = true;
        }
        return isOnGround;
    }
   /**
     * The method is called to make the coins spawn randomly
     * 
     * 
    */
    public void touchCoin(){
        if(isTouching(Coin.class)){
            //In this if statement, if you touch the coin it goes to a different position and your score increases
            removeTouching(Coin.class);
            int width = Greenfoot.getRandomNumber(1000)+2;
            int height = Greenfoot.getRandomNumber(650)+550;
            getWorld().addObject(new Coin(),width,height);
            coins++;
        }
    }
    /**
     * The method is called to display your score
     * 
     * 
    */
    public void showStats(){
        getWorld().showText("Player 1 Coins", 920, 620);
        getWorld().showText(coins+"", 920, 650);
 
    }
    /**
     * The method is called to move the actor back to the begining if the ball hit the actor.
     * 
     * 
    */
    public void kill(){
        if(isTouching(BGuy.class) && wasHit==false){
        setLocation(50, 1190);
        jump();
        wasHit = true;
    }
    }
    /**
     * The method is called to move the actor back to the begining if the ball hit the actor.
     * 
     * 
    */
    public void kill2(){
        if(isTouching(BGuyLeft.class) && wasHit2==false){
        setLocation(50, 1190);
        jump();
        wasHit2 = true;
    }
    }
    /**
     * The method is called so the actor can't jump through platforms
     * 
     * 
    */
    public boolean didBumpHead(){
        boolean bumpHead = false;
        //gets image dimensions
        int imageWidth = getImage().getWidth();
        int imageHeight = getImage().getHeight();
        //Checks if there is a platform
        if(getOneObjectAtOffset(0,imageHeight/-2+1,Platform.class)!=null){
            bumpHead = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/-2+1,Platform2.class)!=null){
            bumpHead = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/-2+1,Platform3.class)!=null){
            bumpHead = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/-2+1,Floor.class)!=null){
            bumpHead = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/-2+1,Floor2.class)!=null){
            bumpHead = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/-2+1,Platform4.class)!=null){
            bumpHead = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/-2+1,Platform5.class)!=null){
            bumpHead = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/-2+1,Platform6.class)!=null){
            bumpHead = true;
        }
          if(getOneObjectAtOffset(0,imageHeight/-2+1,Platform7.class)!=null){
            bumpHead = true;
        }
        return bumpHead;
    }
    /**
     *This method is used to change screen to winner screen if Player 1 wins
     * 
     * 
    */
    public void changeScreen(){
        //If player 1 gets 50 coins then he/she wins
        if(coins==50){
            Greenfoot.setWorld(new Player1WInner());
        }
    }
    
}
