
    import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
    
    /**
     * Write a description of class BGuy here.
     * 
     * @author (your name) 
     * @version (a version number or a date)
     */
    public class BGuy extends Actor
    {
    
    private final int Gravity=1;
    private int velocity;
        public BGuy(){
       //This sets the speed of the ball.
       velocity=0;
       
    }
    /**
     * Act - do whatever the BGuy wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        move();
        fall();
        //This adds the second ball into the game.
        if(getY()>getWorld().getWidth()-1){
        getWorld().addObject(new BGuyLeft(), getX(), getY());
        getWorld().removeObject(this);
        }
    }
    /**
	 * The method is called so the actor can fall down onto the ground.
	 * 
	 * 
	*/
    public void fall(){
        setLocation(getX(), getY() + velocity);
      //The if statement checks if the actor is on a platform and if not then brings the actor down.
        if(isOnSolidGround()){
        velocity = 0;
        }
      else{
         velocity+=Gravity;
        }
    }
    /**
	 * The method is called to move the ball to the right;
	 * 
	 * 
	*/
    public void move(){
        int y = getY();
        int x = getX();
        //The x-coordinate increments causing the ball to move to the right.
        x+=6;
        setLocation(x, y);
    }
    /**
	 * The method is called to check if there is a ground the actor can stand on
	 * 
	 * 
	*/
    public boolean isOnSolidGround(){
        boolean isOnGround = false;
        //Gets the dimensions of the image.
        int imageWidth = getImage().getWidth();
        int imageHeight = getImage().getHeight();
        //These if statements are used to determine if the actor is standing on a platform or not
        if(getOneObjectAtOffset(0,imageHeight/2+1,Platform.class)!=null){
            isOnGround = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/2+1,Platform2.class)!=null){
            isOnGround = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/2+1,Platform3.class)!=null){
            isOnGround = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/2+1,Floor.class)!=null){
            isOnGround = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/2+1,Floor2.class)!=null){
            isOnGround = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/2+1,Platform4.class)!=null){
            isOnGround = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/2+1,Platform5.class)!=null){
            isOnGround = true;
        }
        if(getOneObjectAtOffset(0,imageHeight/2+1,Platform6.class)!=null){
            isOnGround = true;
        }
        return isOnGround;
    }
}
